// Code generated by go-swagger; DO NOT EDIT.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"net/http"
	"strings"

	errors "github.com/go-openapi/errors"
	loads "github.com/go-openapi/loads"
	runtime "github.com/go-openapi/runtime"
	middleware "github.com/go-openapi/runtime/middleware"
	security "github.com/go-openapi/runtime/security"
	spec "github.com/go-openapi/spec"
	strfmt "github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"webank/DI/restapi/api_v1/server/operations/experiments"
	"webank/DI/restapi/api_v1/server/operations/models"
	"webank/DI/restapi/api_v1/server/operations/training_data"
)

// NewDiAPI creates a new Di instance
func NewDiAPI(spec *loads.Document) *DiAPI {
	return &DiAPI{
		handlers:              make(map[string]map[string]http.Handler),
		formats:               strfmt.Default,
		defaultConsumes:       "application/json",
		defaultProduces:       "application/json",
		customConsumers:       make(map[string]runtime.Consumer),
		customProducers:       make(map[string]runtime.Producer),
		ServerShutdown:        func() {},
		spec:                  spec,
		ServeError:            errors.ServeError,
		BasicAuthenticator:    security.BasicAuth,
		APIKeyAuthenticator:   security.APIKeyAuth,
		BearerAuthenticator:   security.BearerAuth,
		JSONConsumer:          runtime.JSONConsumer(),
		MultipartformConsumer: runtime.DiscardConsumer,
		JSONProducer:          runtime.JSONProducer(),
		BinProducer:           runtime.ByteStreamProducer(),
		ExperimentsCodeUploadHandler: experiments.CodeUploadHandlerFunc(func(params experiments.CodeUploadParams) middleware.Responder {
			return middleware.NotImplemented("operation ExperimentsCodeUpload has not yet been implemented")
		}),
		ModelsDeleteModelHandler: models.DeleteModelHandlerFunc(func(params models.DeleteModelParams) middleware.Responder {
			return middleware.NotImplemented("operation ModelsDeleteModel has not yet been implemented")
		}),
		ModelsDownloadModelDefinitionHandler: models.DownloadModelDefinitionHandlerFunc(func(params models.DownloadModelDefinitionParams) middleware.Responder {
			return middleware.NotImplemented("operation ModelsDownloadModelDefinition has not yet been implemented")
		}),
		ModelsDownloadTrainedModelHandler: models.DownloadTrainedModelHandlerFunc(func(params models.DownloadTrainedModelParams) middleware.Responder {
			return middleware.NotImplemented("operation ModelsDownloadTrainedModel has not yet been implemented")
		}),
		ModelsExportModelHandler: models.ExportModelHandlerFunc(func(params models.ExportModelParams) middleware.Responder {
			return middleware.NotImplemented("operation ModelsExportModel has not yet been implemented")
		}),
		GetDashboardsHandler: GetDashboardsHandlerFunc(func(params GetDashboardsParams) middleware.Responder {
			return middleware.NotImplemented("operation GetDashboards has not yet been implemented")
		}),
		TrainingDataGetLoglinesHandler: training_data.GetLoglinesHandlerFunc(func(params training_data.GetLoglinesParams) middleware.Responder {
			return middleware.NotImplemented("operation TrainingDataGetLoglines has not yet been implemented")
		}),
		ModelsGetLogsHandler: models.GetLogsHandlerFunc(func(params models.GetLogsParams) middleware.Responder {
			return middleware.NotImplemented("operation ModelsGetLogs has not yet been implemented")
		}),
		ModelsGetModelHandler: models.GetModelHandlerFunc(func(params models.GetModelParams) middleware.Responder {
			return middleware.NotImplemented("operation ModelsGetModel has not yet been implemented")
		}),
		ModelsListModelsHandler: models.ListModelsHandlerFunc(func(params models.ListModelsParams) middleware.Responder {
			return middleware.NotImplemented("operation ModelsListModels has not yet been implemented")
		}),
		ModelsPatchModelHandler: models.PatchModelHandlerFunc(func(params models.PatchModelParams) middleware.Responder {
			return middleware.NotImplemented("operation ModelsPatchModel has not yet been implemented")
		}),
		ModelsPostModelHandler: models.PostModelHandlerFunc(func(params models.PostModelParams) middleware.Responder {
			return middleware.NotImplemented("operation ModelsPostModel has not yet been implemented")
		}),
	}
}

/*DiAPI Prophecis Rest Service
 */
type DiAPI struct {
	spec            *loads.Document
	context         *middleware.Context
	handlers        map[string]map[string]http.Handler
	formats         strfmt.Registry
	customConsumers map[string]runtime.Consumer
	customProducers map[string]runtime.Producer
	defaultConsumes string
	defaultProduces string
	Middleware      func(middleware.Builder) http.Handler

	// BasicAuthenticator generates a runtime.Authenticator from the supplied basic auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	BasicAuthenticator func(security.UserPassAuthentication) runtime.Authenticator
	// APIKeyAuthenticator generates a runtime.Authenticator from the supplied token auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	APIKeyAuthenticator func(string, string, security.TokenAuthentication) runtime.Authenticator
	// BearerAuthenticator generates a runtime.Authenticator from the supplied bearer token auth function.
	// It has a default implementation in the security package, however you can replace it for your particular usage.
	BearerAuthenticator func(string, security.ScopedTokenAuthentication) runtime.Authenticator

	// JSONConsumer registers a consumer for a "application/json" mime type
	JSONConsumer runtime.Consumer
	// MultipartformConsumer registers a consumer for a "multipart/form-data" mime type
	MultipartformConsumer runtime.Consumer

	// JSONProducer registers a producer for a "application/json" mime type
	JSONProducer runtime.Producer
	// BinProducer registers a producer for a "application/octet-stream" mime type
	BinProducer runtime.Producer

	// ExperimentsCodeUploadHandler sets the operation handler for the code upload operation
	ExperimentsCodeUploadHandler experiments.CodeUploadHandler
	// ModelsDeleteModelHandler sets the operation handler for the delete model operation
	ModelsDeleteModelHandler models.DeleteModelHandler
	// ModelsDownloadModelDefinitionHandler sets the operation handler for the download model definition operation
	ModelsDownloadModelDefinitionHandler models.DownloadModelDefinitionHandler
	// ModelsDownloadTrainedModelHandler sets the operation handler for the download trained model operation
	ModelsDownloadTrainedModelHandler models.DownloadTrainedModelHandler
	// ModelsExportModelHandler sets the operation handler for the export model operation
	ModelsExportModelHandler models.ExportModelHandler
	// GetDashboardsHandler sets the operation handler for the get dashboards operation
	GetDashboardsHandler GetDashboardsHandler
	// TrainingDataGetLoglinesHandler sets the operation handler for the get loglines operation
	TrainingDataGetLoglinesHandler training_data.GetLoglinesHandler
	// ModelsGetLogsHandler sets the operation handler for the get logs operation
	ModelsGetLogsHandler models.GetLogsHandler
	// ModelsGetModelHandler sets the operation handler for the get model operation
	ModelsGetModelHandler models.GetModelHandler
	// ModelsListModelsHandler sets the operation handler for the list models operation
	ModelsListModelsHandler models.ListModelsHandler
	// ModelsPatchModelHandler sets the operation handler for the patch model operation
	ModelsPatchModelHandler models.PatchModelHandler
	// ModelsPostModelHandler sets the operation handler for the post model operation
	ModelsPostModelHandler models.PostModelHandler

	// ServeError is called when an error is received, there is a default handler
	// but you can set your own with this
	ServeError func(http.ResponseWriter, *http.Request, error)

	// ServerShutdown is called when the HTTP(S) server is shut down and done
	// handling all active connections and does not accept connections any more
	ServerShutdown func()

	// Custom command line argument groups with their descriptions
	CommandLineOptionsGroups []swag.CommandLineOptionsGroup

	// User defined logger function.
	Logger func(string, ...interface{})
}

// SetDefaultProduces sets the default produces media type
func (o *DiAPI) SetDefaultProduces(mediaType string) {
	o.defaultProduces = mediaType
}

// SetDefaultConsumes returns the default consumes media type
func (o *DiAPI) SetDefaultConsumes(mediaType string) {
	o.defaultConsumes = mediaType
}

// SetSpec sets a spec that will be served for the clients.
func (o *DiAPI) SetSpec(spec *loads.Document) {
	o.spec = spec
}

// DefaultProduces returns the default produces media type
func (o *DiAPI) DefaultProduces() string {
	return o.defaultProduces
}

// DefaultConsumes returns the default consumes media type
func (o *DiAPI) DefaultConsumes() string {
	return o.defaultConsumes
}

// Formats returns the registered string formats
func (o *DiAPI) Formats() strfmt.Registry {
	return o.formats
}

// RegisterFormat registers a custom format validator
func (o *DiAPI) RegisterFormat(name string, format strfmt.Format, validator strfmt.Validator) {
	o.formats.Add(name, format, validator)
}

// Validate validates the registrations in the DiAPI
func (o *DiAPI) Validate() error {
	var unregistered []string

	if o.JSONConsumer == nil {
		unregistered = append(unregistered, "JSONConsumer")
	}

	if o.MultipartformConsumer == nil {
		unregistered = append(unregistered, "MultipartformConsumer")
	}

	if o.JSONProducer == nil {
		unregistered = append(unregistered, "JSONProducer")
	}

	if o.BinProducer == nil {
		unregistered = append(unregistered, "BinProducer")
	}

	if o.ExperimentsCodeUploadHandler == nil {
		unregistered = append(unregistered, "experiments.CodeUploadHandler")
	}

	if o.ModelsDeleteModelHandler == nil {
		unregistered = append(unregistered, "models.DeleteModelHandler")
	}

	if o.ModelsDownloadModelDefinitionHandler == nil {
		unregistered = append(unregistered, "models.DownloadModelDefinitionHandler")
	}

	if o.ModelsDownloadTrainedModelHandler == nil {
		unregistered = append(unregistered, "models.DownloadTrainedModelHandler")
	}

	if o.ModelsExportModelHandler == nil {
		unregistered = append(unregistered, "models.ExportModelHandler")
	}

	if o.GetDashboardsHandler == nil {
		unregistered = append(unregistered, "GetDashboardsHandler")
	}

	if o.TrainingDataGetLoglinesHandler == nil {
		unregistered = append(unregistered, "training_data.GetLoglinesHandler")
	}

	if o.ModelsGetLogsHandler == nil {
		unregistered = append(unregistered, "models.GetLogsHandler")
	}

	if o.ModelsGetModelHandler == nil {
		unregistered = append(unregistered, "models.GetModelHandler")
	}

	if o.ModelsListModelsHandler == nil {
		unregistered = append(unregistered, "models.ListModelsHandler")
	}

	if o.ModelsPatchModelHandler == nil {
		unregistered = append(unregistered, "models.PatchModelHandler")
	}

	if o.ModelsPostModelHandler == nil {
		unregistered = append(unregistered, "models.PostModelHandler")
	}

	if len(unregistered) > 0 {
		return fmt.Errorf("missing registration: %s", strings.Join(unregistered, ", "))
	}

	return nil
}

// ServeErrorFor gets a error handler for a given operation id
func (o *DiAPI) ServeErrorFor(operationID string) func(http.ResponseWriter, *http.Request, error) {
	return o.ServeError
}

// AuthenticatorsFor gets the authenticators for the specified security schemes
func (o *DiAPI) AuthenticatorsFor(schemes map[string]spec.SecurityScheme) map[string]runtime.Authenticator {

	return nil

}

// Authorizer returns the registered authorizer
func (o *DiAPI) Authorizer() runtime.Authorizer {

	return nil

}

// ConsumersFor gets the consumers for the specified media types
func (o *DiAPI) ConsumersFor(mediaTypes []string) map[string]runtime.Consumer {

	result := make(map[string]runtime.Consumer)
	for _, mt := range mediaTypes {
		switch mt {

		case "application/json":
			result["application/json"] = o.JSONConsumer

		case "multipart/form-data":
			result["multipart/form-data"] = o.MultipartformConsumer

		}

		if c, ok := o.customConsumers[mt]; ok {
			result[mt] = c
		}
	}
	return result

}

// ProducersFor gets the producers for the specified media types
func (o *DiAPI) ProducersFor(mediaTypes []string) map[string]runtime.Producer {

	result := make(map[string]runtime.Producer)
	for _, mt := range mediaTypes {
		switch mt {

		case "application/json":
			result["application/json"] = o.JSONProducer

		case "application/octet-stream":
			result["application/octet-stream"] = o.BinProducer

		}

		if p, ok := o.customProducers[mt]; ok {
			result[mt] = p
		}
	}
	return result

}

// HandlerFor gets a http.Handler for the provided operation method and path
func (o *DiAPI) HandlerFor(method, path string) (http.Handler, bool) {
	if o.handlers == nil {
		return nil, false
	}
	um := strings.ToUpper(method)
	if _, ok := o.handlers[um]; !ok {
		return nil, false
	}
	if path == "/" {
		path = ""
	}
	h, ok := o.handlers[um][path]
	return h, ok
}

// Context returns the middleware context for the di API
func (o *DiAPI) Context() *middleware.Context {
	if o.context == nil {
		o.context = middleware.NewRoutableContext(o.spec, o, nil)
	}

	return o.context
}

func (o *DiAPI) initHandlerCache() {
	o.Context() // don't care about the result, just that the initialization happened

	if o.handlers == nil {
		o.handlers = make(map[string]map[string]http.Handler)
	}

	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/di/v1/codeUpload"] = experiments.NewCodeUpload(o.context, o.ExperimentsCodeUploadHandler)

	if o.handlers["DELETE"] == nil {
		o.handlers["DELETE"] = make(map[string]http.Handler)
	}
	o.handlers["DELETE"]["/di/v1/models/{model_id}"] = models.NewDeleteModel(o.context, o.ModelsDeleteModelHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/di/v1/models/{model_id}/definition"] = models.NewDownloadModelDefinition(o.context, o.ModelsDownloadModelDefinitionHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/di/v1/models/{model_id}/trained_model"] = models.NewDownloadTrainedModel(o.context, o.ModelsDownloadTrainedModelHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/di/v1/models/{model_id}/export"] = models.NewExportModel(o.context, o.ModelsExportModelHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/di/v1/dashboards"] = NewGetDashboards(o.context, o.GetDashboardsHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/di/v1/logs/{model_id}/loglines"] = training_data.NewGetLoglines(o.context, o.TrainingDataGetLoglinesHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/di/v1/models/{model_id}/logs"] = models.NewGetLogs(o.context, o.ModelsGetLogsHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/di/v1/models/{model_id}"] = models.NewGetModel(o.context, o.ModelsGetModelHandler)

	if o.handlers["GET"] == nil {
		o.handlers["GET"] = make(map[string]http.Handler)
	}
	o.handlers["GET"]["/di/v1/models"] = models.NewListModels(o.context, o.ModelsListModelsHandler)

	if o.handlers["PATCH"] == nil {
		o.handlers["PATCH"] = make(map[string]http.Handler)
	}
	o.handlers["PATCH"]["/di/v1/models/{model_id}"] = models.NewPatchModel(o.context, o.ModelsPatchModelHandler)

	if o.handlers["POST"] == nil {
		o.handlers["POST"] = make(map[string]http.Handler)
	}
	o.handlers["POST"]["/di/v1/models"] = models.NewPostModel(o.context, o.ModelsPostModelHandler)

}

// Serve creates a http handler to serve the API over HTTP
// can be used directly in http.ListenAndServe(":8000", api.Serve(nil))
func (o *DiAPI) Serve(builder middleware.Builder) http.Handler {
	o.Init()

	if o.Middleware != nil {
		return o.Middleware(builder)
	}
	return o.context.APIHandler(builder)
}

// Init allows you to just initialize the handler cache, you can then recompose the middleware as you see fit
func (o *DiAPI) Init() {
	if len(o.handlers) == 0 {
		o.initHandlerCache()
	}
}

// RegisterConsumer allows you to add (or override) a consumer for a media type.
func (o *DiAPI) RegisterConsumer(mediaType string, consumer runtime.Consumer) {
	o.customConsumers[mediaType] = consumer
}

// RegisterProducer allows you to add (or override) a producer for a media type.
func (o *DiAPI) RegisterProducer(mediaType string, producer runtime.Producer) {
	o.customProducers[mediaType] = producer
}
